Re: dropping -Wl,--export-dynamic (Re: GTK+ team irc meeting)

On Tue, 2006-03-07 at 17:42 +0100, Tim Janik wrote:
> On Tue, 7 Mar 2006, Matthias Clasen wrote:
> > Place:
> > Time: 21:00 UTC (16:00 EST), Tue, March 7
> >
> > Possible agenda items:
> [...]
> > - dropping -Wl,--export-dynamic
> upon behdad's request, here's the relevant background on removal of
> gmodule-2.0.pc, respectively -Wl,--export-dynamic:
> Mar 06 22:26:47 *	rambokid kicks gmodule-2.0.pc for having --export-dynamic
> Mar 06 22:27:56 <tko>	rambokid, gmodule-no-export-2.0.pc ? (backwards compatibility I suppose?)
> Mar 06 22:29:20 <rambokid>	tko: that doesn't help as --export-dynamic already propagated into dependent libraries (e.g. libgnomecanvas)
> Mar 06 22:31:11 <rambokid>	matthias: around? we should remove --export-dynamic from gmodule-2.0.pc since you added gmodule-export-2.0.pc
> Mar 06 22:36:55 <matthias>	rambokid: maybe. OTOH, we have gmodule-export and gmodule-no-export now, so we could just deprecate the gmodule-2.0.pc file
> Mar 06 22:37:43 <rambokid>	matthias: i don't think that helps, unless you actually stop to install that file. (otherwise people won't update their scripts and dependent libraries are still affected).
> Mar 06 22:38:14 <rambokid>	matthias: simply removing --export-dynamic should be easiest for all though. people that really depend on that flag will notice and can swictch to module-export easily.
> Mar 06 22:40:08 <rambokid>	matthias: getting rid of that flag is important, it actually causes real breakage, such as: libgnomecanvas adopts the --export-dynamic flag, and then every library that links against libgnomecanvas gets that flag passed. that in turn can break linking for a lot of libraries, since other linker flags may only be used in absence of --export-dynamic (like --version-script as recommended in the dsohowto)
> Mar 06 22:41:21 <rambokid>	so dependednt libraries are really screwed (unless they do ugly hackery such as trying to remove the flag again via sed or similar)
> Mar 06 22:42:07 <matthias>	hmm, can we do this in the middle of a stable series ? or is this 2.12 material ?
> Mar 06 22:42:42 <rambokid>	matthias: i don't mind making this change, it does make sense and has little impact (only plugin authors could notice).
> Mar 06 22:43:02 <rambokid>	matthias: to be sure though, you can ask owen. he tends to be much more conservative about such things than me ;)
> Mar 06 22:45:26 <matthias>	rambokid: I'll ask owen next time I see him (which could be tomorrow or next month...)
> Mar 06 22:46:18 <rambokid>	matthias: ok.
> Mar 07 16:46:50 <behdad>        mclasen: seems like I will miss the meeting.  can you point me to relevant discussion about dropping -Wl,--export-dynamic?

No real opinion. Is it 100% compatible? No. Is it compatible enough?

(The libgnomecanvas thing though seems spurious to me... you'd be
better off fixing it directly.)

[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]